//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  DimGray
#property indicator_color4  DeepSkyBlue
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  3
#property indicator_width7  3
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT

//
//
//
//
//

extern double CPAlpha         = 0.07;
extern int    ChannelLength   = 10;
extern int    Price           = PRICE_CLOSE;
extern bool   AlertsOn        = false;
extern bool   AlertsOnCurrent = true;
extern bool   AlertsMessage   = true;
extern bool   AlertsSound     = false;
extern bool   AlertsEmail     = false;


double cum[];
double cumDa[];
double cumDb[];
double cumUa[];
double cumUb[];
double chu[];
double chd[];
double trend[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,chu);
      SetIndexBuffer(1,chd);
      SetIndexBuffer(2,cum);
      SetIndexBuffer(3,cumUa);
      SetIndexBuffer(4,cumUb);
      SetIndexBuffer(5,cumDa);
      SetIndexBuffer(6,cumDb);
      SetIndexBuffer(7,trend);
   return(0); 
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double work[][3];
#define _trend 0
#define _slope 1
#define _lsma  2

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   if (work[Bars-limit-1][_trend] ==  1 && work[Bars-limit-1][_slope] ==  1) CleanPoint(limit,cumUa,cumUb);
   if (work[Bars-limit-1][_trend] == -1 && work[Bars-limit-1][_slope] == -1) CleanPoint(limit,cumDa,cumDb);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int Length = iCustom(NULL,0,"CyclePeriod",CPAlpha,0,i);
         work[r][_lsma] = 3.0*iMA(NULL,0,Length,0,MODE_LWMA,Price,i)-2.0*iMA(NULL,0,Length,0,MODE_SMA,Price,i);
         double lsmac = work[r  ][_lsma];
         double lsmap = work[r-1][_lsma];
         cum[i] = cum[i+1];
            if (lsmac > lsmap) cum[i] += 1;
            if (lsmac < lsmap) cum[i] -= 1;
         chu[i] = cum[ArrayMaximum(cum,ChannelLength,i)];
         chd[i] = cum[ArrayMinimum(cum,ChannelLength,i)];
         cumUa[i] = EMPTY_VALUE;
         cumUb[i] = EMPTY_VALUE;
         cumDa[i] = EMPTY_VALUE;
         cumDb[i] = EMPTY_VALUE;
         work[r][_trend] = work[r-1][_trend];
         work[r][_slope] = work[r-1][_slope];
            if (chu[i]>chu[i+1]) work[r][_trend] =  1;
            if (chd[i]<chd[i+1]) work[r][_trend] = -1;
            if (cum[i]>cum[i+1]) work[r][_slope] =  1;
            if (cum[i]<cum[i+1]) work[r][_slope] = -1;
            if (work[r][_trend] ==  1 && work[r][_slope] ==  1) PlotPoint(i,cumUa,cumUb,cum);
            if (work[r][_trend] == -1 && work[r][_slope] == -1) PlotPoint(i,cumDa,cumDb,cum);
         trend[i] = work[r][_trend];
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

      if (trend[whichBar]!= trend[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar] ==  1) doAlert(time1,mess1," LSMA channeled trend changed to up");
            if (trend[whichBar] == -1) doAlert(time1,mess1," LSMA channeled trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" LSMA channeled",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}